#include <avr/io.h>

int main(void)
{
    uint8_t akku;

    //MOSI / PB5 als Output
    DDRB |= 0b00100000;
    //MISO / PB6 als Input
    DDRB &= 0b10111111;
    //SCK  / PB7 als Output (fr den Synchronisationstakt)
    DDRB |= 0b10000000;

    //SPI-Schnittstelle als Master ohne Interrupts konfigurieren und starten:
    SPCR = (0<<SPIE) | (1<<SPE) | (0<<DORD) | (1<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);            


    //Slave Select Ausgnge PA1 und PA2 als Ausgnge:
    DDRA  |= 0b00000110;
    PORTA |= 0b00000110; //Slave-select auf High setzen

    //8-Bit-Parallel-Verbindung zu erstem Mikrocontroller (muecA), also PORTC als Ausgang:
    DDRC = 0b11111111;
    //Null anzeigen lassen, solange Taster nicht das erste mal gedrckt wurde.
    PORTC = 0;
		    
	while(1)
	{		
		if(PINB & (1<<PINB0))  //Wenn Taster PB0 gedrckt
		{
            //PA1 auf Low, d.h. Slave 1 anwhlen:
            PORTA &= 0b11111101;
            //Zu sendende Zahl 15 fr den Sende/Empfangszyklus in das SPI-Datenregister schreiben:
            SPDR = 15;
            //Warten, bis Flag fr erfolgreiche Datenbertragung gesetzt ist:
            while( (SPSR & (1<<SPIF)) == 0);

            akku = SPCR; //Durch Auslesen der Register SPCR und SPDR Interrupt wieder freigeben
            //Empfangenes Byte nach Port C schicken, um es dezimal anzeigen zu lassen:
            akku = SPDR;
            PORTC = akku;
            
            //Slave-select beider Slaves wieder auf high-Pegel:
            PORTA |= 0b00000110;

            //Warten, bis Taste bei PB0 wieder losgelassen wird
			while(PINB & (1<<PINB0));
		}
		
	}
	return 0;
}
